
void setup()
{
  // sanity check delay - allows reprogramming if accidently blowing power w/leds
  delay(2000);
  FastLED.addLeds<APA102, BGR>(leds, NUM_LEDS); // Order of R,G,B data depends on manufacturer of LED strip.
  pinMode(7, OUTPUT);
  digitalWrite(7, HIGH);  // enable access to LEDs

  for(byte i = 0; i < NUM_LEDS; i++)
  {
    leds[i] = CRGB(0,0,0);
  }
  FastLED.show();
 
  // Connect the handleNoteOn function to the library,
  // so it is called upon reception of a NoteOn.
  usbMIDI.setHandleNoteOn(OnNoteOn);  // Put only the name of the function

  // Do the same for NoteOffs
  usbMIDI.setHandleNoteOff(OnNoteOff);

  pinMode(13, OUTPUT); // Optional indicator LED.
}

