
void fadeoff_update (void)

{
  current_millis = millis();

  byte absolute_brightness;
  byte light_number;

  for (light_number = 0; light_number < NUM_LEDS; light_number++)
  {
    if (current_brightness_index[light_number])
    {
      if (noteon[light_number])
      {
        if (fadeup)
        {
          if (current_millis > start_millis[light_number] + fadeup_time)
          {
            if (note_on_sustain && (current_millis > start_millis[light_number] + fadeup_time + noteon_sustain_at))
            { }  // do nothing for sustain
            else
            {
              current_brightness_index[light_number] = fadeoff_map(current_millis, start_millis[light_number] + fadeup_time, start_brightness_index[light_number], noteon_fade_bitshift, 1);
            }
          }
          else
          {
            byte tempvalue = (start_brightness_index[light_number] * (current_millis - start_millis[light_number])) >> fadeup_BS;  // linear fade up
            if (tempvalue >= current_brightness_index[light_number])
              current_brightness_index[light_number] = tempvalue;
            if (!current_brightness_index[light_number])
            {
              current_brightness_index[light_number] = 1; // Ensures that light turns on.  Avoid zero value during fade up.
            }
          }
        }
        else
        {
          current_brightness_index[light_number] = fadeoff_map(current_millis, start_millis[light_number], start_brightness_index[light_number], noteon_fade_bitshift, 1);
        }
      }

      else if (fadeoff_noteoff)
      {
        current_brightness_index[light_number] = fadeoff_map(current_millis, start_millis[light_number], start_brightness_index[light_number], noteoff_fade_bitshift, 0);
      }

      if (relative_curve)
      {
        absolute_brightness = (current_brightness_index[light_number] * curve[255 * current_brightness_index[light_number] / start_brightness_index[light_number]]) >> 8;
      }

      else
      {
        absolute_brightness = curve[current_brightness_index[light_number]];
      }

      leds[light_number] = CRGB(HB2red(hue[light_number + lowest_note], absolute_brightness), HB2green(hue[light_number + lowest_note], absolute_brightness), HB2blue(hue[light_number + lowest_note], absolute_brightness));
    }
  }

  FastLED.show();

}

