
void OnNoteOn(byte channel, byte pitch, byte velocity)
{
  if ((pitch >= lowest_note) && (pitch < (lowest_note + NUM_LEDS)) && (!ignore_percussion || channel != percussion_channel))
  {

    indicator_LED_start_millis = millis();
    indicator_LED_end_millis = indicator_LED_start_millis + 25;
    digitalWriteFast(indicator_LED_pin, HIGH);

    for (byte buffer_index = 0; buffer_index < max_buffered_notes; buffer_index++)
    {
      if (!scheduled_noteon_start_millis[pitch - lowest_note][buffer_index])
      {

        scheduled_noteon_start_millis[pitch - lowest_note][buffer_index] = millis() + audio_latency;

        if (velocity_sensitive_brightness)
        {
          unsigned int tempvalue = (velocity << volumeBS) + 1;
          if (tempvalue > 255)
          {
            tempvalue = 255;
          }
          scheduled_start_brightness_index[pitch - lowest_note][buffer_index] = tempvalue;
        }
        else
        {
          scheduled_start_brightness_index[pitch - lowest_note][buffer_index] = 255;
        }

        break;
      }
    }
  }
}

void OnNoteOff(byte channel, byte pitch, byte velocity)
{
  if ((pitch >= lowest_note) && (pitch < (lowest_note + NUM_LEDS)) && (!ignore_percussion || channel != percussion_channel))
  {
    indicator_LED_start_millis = millis();
    indicator_LED_end_millis = indicator_LED_start_millis + 25;
    digitalWriteFast(indicator_LED_pin, HIGH);

    for (byte buffer_index = 0; buffer_index < max_buffered_notes; buffer_index++)
    {
      if (!scheduled_noteoff_start_millis[pitch - lowest_note][buffer_index])
      {
        scheduled_noteoff_start_millis[pitch - lowest_note][buffer_index] = millis() + audio_latency;

        break;
      }
    }
  }
}


